A Lattice Linear Predicate Parallel Algorithm for the Dynamic Programming Problems
Abstract
It has been shown that the parallel Lattice Linear Predicate (LLP) algorithm solves many combinatorial optimization problems such as the shortest path problem, the stable marriage problem and the market clearing price problem. In this paper, we give the parallel LLP algorithm for many dynamic programming problems. In particular, we show that the LLP algorithm solves the longest subsequence problem, the optimal binary search tree problem, and the knapsack problem. Furthermore, the algorithm can be used to solve the constrained versions of these problems so long as the constraints are lattice linear. The parallel LLP algorithm requires only read-write atomicity and no higher-level atomic instructions.
1 Introduction
It has been shown that the Lattice Linear Predicate (LLP) algorithm solves many combinatorial optimization problems such as the shortest path problem, the stable marriage problem and the market clearing price problem [1]. In this paper, we show that many problems that can be solved using dynamic programming [2] can also be solved in parallel using the LLP algorithm. Dynamic programming is applicable to problems where it is easy to set up a recurrence relation such that the solution of the problem can be derived from the solutions of problems with smaller sizes. One can solve the problem using recursion; however, recursion may result in many duplicate computations. By using memoization, we can avoid recomputing previously computed values. We assume that the problem is solved using dynamic programming with such bottom-up approach in this paper.
The LLP algorithm views solving a problem as searching for an element in a finite distributive lattice [3, 4, 5] that satisfies a given predicate . The predicate is required to be closed under the operation of meet (or, equivalently lattice-linear, defined in Section 2). For all the problems considered in the paper, the longest subsequence problem, the optimal binary search tree problem and the Knapsack problem, the predicate is indeed closed under meets. Any finite distributive lattice can be equivalently characterized by a finite poset of its join-irreducibles from Birkhoffβs theorem [3, 4]. The LLP algorithm works on the finite poset in parallel to find the least element in the distributive lattice that satisfies the given predicate. It starts with the bottom element of the lattice and marches towards the top element of the lattice in a parallel fashion by advancing on any chain of the poset for which the current element is forbidden.
There are also some key differences between dynamic programming (the bottom-up approach) and the LLP algorithm. The usual dynamic programming problem seeks a structure that minimizes (or maximizes) some scalar. For example, the longest subsequence problem asks for the subsequence in an array that maximizes the sum. In contrast, the LLP algorithm seeks to minimize or maximize a vector. In the longest subsequence problem with the LLP approach, we are interested in the longest subsequence in the array for each that ends at index . Thus, instead of asking for a scalar, we ask for the vector of size . We get an array and the solution to the original problem is just the maximum value in the array . Similarly, the optimal binary search tree problem [6] asks for the construction of an optimal binary search tree on symbols such that each symbol has probability of being searched. Our goal is to find the binary search tree that minimizes the expected cost of search in the tree. The LLP problem seeks the optimal binary search tree for all ranges instead of just one range . Finally, the knapsack problem [7, 8] asks for the maximum valued subset of items that can be fit in a knapsack such that the profit is maximized and the total weight of the knapsack is at most . The LLP problem seeks the maximum profit obtained by choosing items from and the total weight from . In all these problems, traditionally we are seeking a single structure that optimizes a single scalar; whereas the LLP algorithm asks for a vector. It turns out that that in asking for an optimal vector instead of an optimal scalar, we do not lose much since the existing solutions also end up finding the optimal solutions for the subproblems. The LLP algorithm returns a vector such that is optimal for .
The second difference between dynamic programming and the LLP algorithm is in terms of parallelism. The dynamic programming solution does not explicitly refers to parallelism in the problem. The LLP algorithm has an explicit notion of parallelism. The solution uses an array for all problems and the algorithm requires the components of to be advanced whenever they are found to be forbidden. If is forbidden for multiple values of , then can be advanced for all those values in parallel.
The third difference between dynamic programming and the LLP algorithm is in terms of synchronization required during parallel execution of the algorithm. In case of dynamic programming, if the recursive formulas are evaluated in parallel it is assumed that the values used are correct. In contrast, suppose that we check for and to be forbidden concurrently such that ends up using an old value of , the LLP algorithm is still correct. The only requirement we have for parallelism is that when uses a value of , it should either be the most recent value of or some prior value. A processor that is responsible for keeping may get old value from in a parallel setting when it gets this value from a cache. In a message passing system, it may get the old value of if the message to update has not yet arrived at the processor with . Thus, LLP algorithms are naturally parallel with little synchronization overhead.
The fourth difference between dynamic programming and the LLP algorithm is that we can use the LLP algorithm to solve a constrained version of the problem, so long as the constraint itself is lattice-linear. Suppose that we are interested in the longest subsequence such that successive elements differ by at least . It can be (easily) shown that this constraint is lattice-linear. Hence, the LLP algorithm is applicable because we are searching for an element that satisfies a conjunction of two lattice-linear predicates. Since the set of lattice-linear predicates is closed under conjunction, the resulting predicate is also lattice-linear and the LLP algorithm is applicable. Similarly, the predicate that the symbol is not a parent of symbol is lattice-linear and the constrained optimal binary search tree algorithm returns the optimal tree that satisfies the given constraint. In the Knapsack problem, it is easy to solve the problem with the additional constraint that if the item is included in the Knapsack, then the item is also included.
We note here that our goal is not to improve the time or work complexity of the algorithms, but to provide a single parallel algorithm that solve all of these problems and their constrained versions. Furthermore, the parallel algorithm we propose has no synchronization overhead, i.e., they only require read-write atomicity.
This paper is organized as follows. Section 2 gives background on the LLP method. Section 3 gives the programming notation used to express LLP algorithms in the paper. Section 4 applies the LLP method to the longest subsequence problem. Section 5 give a parallel algorithm for the optimal binary search tree construction problem. Section 6 gives an LLP algorithm for the knapsack problem.
2 Background
In this section, we cover the background information on the LLP Algorithm [1]. Let be the lattice of all -dimensional vectors of reals greater than or equal to zero vector and less than or equal to a given vector where the order on the vectors is defined by the component-wise natural . The lattice is used to model the search space of the combinatorial optimization problem. The combinatorial optimization problem is modeled as finding the minimum element in that satisfies a boolean predicate , where models feasible (or acceptable solutions). We are interested in parallel algorithms to solve the combinatorial optimization problem with processes. We will assume that the systems maintains as its state the current candidate vector in the search lattice, where is maintained at process . We call , the global state, and , the state of process .
Fig. 1 shows a finite poset corresponding to processes ( equals two in the figure), and the corresponding lattice of all eleven global states.
Finding an element in lattice that satisfies the given predicate , is called the predicate detection problem. Finding the minimum element that satisfies (whenever it exists) is the combinatorial optimization problem. A key concept in deriving an efficient predicate detection algorithm is that of a forbidden state. Given a predicate , and a vector , a state is forbidden (or equivalently, the index is forbidden) if for any vector , where , if equals , then is false for . Formally,
Definition 1 (Forbidden State [9])
Given any distributive lattice of -dimensional vectors of , and a predicate , we define
We define a predicate to be lattice-linear with respect to a lattice if for any global state , is false in implies that contains a forbidden state. Formally,
Definition 2 (lattice-linear Predicate [9])
A boolean predicate is lattice-linear with respect to a lattice iff .
Once we determine such that , we also need to determine how to advance along index . To that end, we extend the definition of forbidden as follows.
Definition 3 (-forbidden)
Let be any boolean predicate on the lattice of all assignment vectors. For any , and positive real , we define iff
Given any lattice-linear predicate , suppose . This means that must be advanced on all indices such that . We use a function such that holds whenever is true. With the notion of , we have the Algorithm . The algorithm has two inputs β the predicate and the top element of the lattice . It returns the least vector which is less than or equal to and satisfies (if it exists). Whenever is not true in the current vector , the algorithm advances on all forbidden indices in parallel. This simple parallel algorithm can be used to solve a large variety of combinatorial optimization problems by instantiating different and .
The following Lemma is useful in proving lattice-linearity of predicates.
Lemma 1
We now give an example of lattice-linear predicates for scheduling of jobs. Each job requires time for completion and has a set of prerequisite jobs, denoted by , such that it can be started only after all its prerequisite jobs have been completed. Our goal is to find the minimum completion time for each job. We let our lattice be the set of all possible completion times. A completion vector is feasible iff holds where . is lattice-linear because if it is false, then there exists such that either or . We claim that . Indeed, any vector cannot be feasible with equal to . The minimum of all vectors that satisfy feasibility corresponds to the minimum completion time.
As an example of a predicate that is not lattice-linear, consider the predicate defined on the space of two dimensional vectors. Consider the vector equal to . The vector does not satisfy . For to be lattice-linear either the first index or the second index should be forbidden. However, none of the indices are forbidden in . The index is not forbidden because the vector is greater than , has equal to but it still satisfies . The index is also not forbidden because is greater than , has equal to but it satisfies .
3 Notation
We now go over the notation used in description of our parallel algorithms. Fig. 2 shows a parallel algorithm for the job-scheduling problems.
The var section gives the variables of the problem. We have a single variable in the example shown in Fig. 2. is an array of objects such that is the state of thread for a parallel program.
The input section gives all the inputs to the problem. These inputs are constant in the program and do not change during execution.
The init section is used to initialize the state of the program. All the parts of the program are applicable to all values of . For example, the init section of the job scheduling program in Fig. 2 specifies that is initially . Every thread would initialize .
The always section defines additional variables which are derived from . The actual implementation of these variables are left to the system. They can be viewed as macros. We will show its use later.
The LLP algorithm gives the desirable predicate either by using the forbidden predicate or ensure predicate. The forbidden predicate has an associated advance clause that specifies how must be advanced whenever the forbidden predicate is true. For many problems, it is more convenient to use the complement of the forbidden predicate. The ensure section specifies the desirable predicates of the form or . The statement ensure simply means that whenever thread finds to be less than ; it can advance to . Since may refer to , just by setting equal to , there is no guarantee that continues to be equal to β the value of may change because of changes in other components. We use ensure statement whenever is a monotonic function of and therefore the predicate is lattice-linear.
4 Longest Increasing Subsequences
We are given an integer array as input. For simplicity, we assume that all entries are distinct. Our goal is find for each index the length of the longest increasing sequence that ends at . For example, suppose the array is {35 38 27 45 32}. Then, the desired output is {1 2 1 3 2}. The corresponding longest increasing subsequences are: (35), (35, 38), (27), (35, 38, 45), (27, 32).
We can define a graph with indices as vertices. For this example, we have five vertices numbered to . We draw an edge from to if is less than and is also less than . This graph is clearly acyclic as an edge can only go from a lower index to a higher index. We use to be the set of indices which have an incoming edge to . The length of the longest increasing subsequence ending at index is identical to the length of the longest path ending at .
To solve the problem using LLP, we model it as a search for the smallest vector that satisfies the constraint . To understand , we first consider a stronger predicate . The interpretation of in is that it is the length of the longest path that ends in . Thus, in the longest increasing subsequence problem we are searching for the vector that satisfies the predicate . Instead of searching for an element in the lattice that satisfies , we search for the least element in the lattice that satisfies . This allows us to solve for the constrained version of the problem in which we are searching for an element that satisfies an additional lattice-linear constraint.
The underlying lattice we consider is that of all vectors of natural numbers less than or equal to the maximum element in the lattice. A vector in this lattice is feasible if it satisfies . We first show that the constraint is lattice-linear.
Lemma 2
The constraint is lattice-linear.
Proof: Since the predicate is a conjunction of two predicates, it is sufficient to show that each of them is lattice-linear from Lemma 1(b). The first conjunct is lattice linear because the constant function is monotone. The second conjunct can be viewed as a conjunction over all . For a fixed , the predicate is lattice-linear from Lemma 1(a). Β Β
Our goal is to find the smallest vector in the lattice that satisfies . Now, LLP algorithm can be formulated as 2.
This algorithm starts with all values as and increases the vector till it satisfies the constraint . The above algorithm, although correct, does not preclude from getting updated multiple times. To ensure that no is updated more than once, we introduce a boolean for each index such that we update only when it is not fixed and all its predecessors are fixed. With this change, our algorithm becomes 3.
Let us now analyze the complexity of the algorithm. The sequential complexity is simple because we can maintain the list of all vertices that are forbidden because all its predecessors are fixed. Once we have processed a vertex, we never process it again. This is similar to a sequential algorithm of topological sort. In this case, we examine a vertex exactly once only after all its predecessors are fixed. The time complexity of this algorithm is .
For the parallel time complexity, assume that we have processors available. Then, in time , one can determine whether the vertex is forbidden and advance it to the correct value if it is forbidden. This is because for every , we simply need to check that all vertices in are fixed and is not fixed. By using a parallel reduce operation, we can check in time whether is forbidden. If the longest path in the graph is , then the algorithm takes time.
Now, let us consider the situation where each thread writes the value of and without using any synchronization. If any thread reads the old value of for some in , it will not update at that point. Eventually, it will read the correct value of , and perform . We do assume in this version that if a process reads as true, then it reads the correct value of , because is updated after . Consequently, we get the following result.
Lemma 3
There exists a parallel algorithm for the longest increasing subsequence problem which uses just read-write atomicity and solves the problem in time.
We now add lattice-linear constraints to the problem. Instead of the longest increasing subsequence, we may be interested in the longest increasing subsequence that satisfies an additional predicate.
Lemma 4
All the following predicates are lattice linear.
-
1.
For any , is greater than or equal to the longest increasing subsequence of odd integers ending at .
-
2.
is greater than or equal to the longest increasing subsequence such that element in the subsequence exceeds element by at least .
Proof:
-
1.
Since lattice-linear predicates are closed under conjunction, it is sufficient to focus on a fixed . If is less than the length of the longest increasing subsequence of odd integers ending at , then the index is forbidden. Unless is increased the predicate can never become true.
-
2.
We view this predicate as redrawing the directed graph such that we draw an edge from to if is less than and is less than or equal to .
Β
We note here that the problem can also be solved in parallel using repeated squaring of an appropriate matrix. We do not discuss that method here since it is not work-optimal and generally not efficient in practice.
5 Optimal Binary Search Tree
Suppose that we have a fixed set of symbols called keys with some associated information called values. Our goal is to build a dictionary based on binary search tree out of these symbols. The dictionary supports a single operation search which returns the value associated with the the given key. We are also given the frequency of each symbol as the argument for the search query. The cost of any search for a given key is given by the length of the path from the root of the binary search tree to the node containing that key. Given any binary search tree, we can compute the total cost of the tree for all searches. We would like to build the binary search tree with the least cost.
Let the frequency of key being searched is . We assume that the keys are sorted in increasing order of . Our algorithm is based on building progressively bigger binary search trees. The main idea is as follows. Suppose symbol is the root of an optimal binary search tree for symbols in the range . The root divides the range into three parts β the range of indices strictly less than , the index , and the range of indices strictly greater than . The left or the right range may be empty. Then, the left subtree and the right subtree must themselves be optimal for their respective ranges. Let denote the least cost of any binary search tree built from symbols in the range . We use the symbol as the sum of all frequencies from the symbol to , i.e.,
For convenience, we let equal to whenever , i.e., the range is empty.
We now define a lattice linear constraint on . Let . Consider the cost of the optimal tree such that symbol is at the root. The cost has three components: the cost of the left subtree if any, the cost of the search ending at this node itself and the cost of search in the right subtree. The cost of the left subtree is
whenever . The cost of the node itself is . The cost of the right subtree is
Combining these expressions, we get
This is also the least value of such that
We now show that the above predicate is lattice-linear.
Lemma 5
The constraint is lattice-linear.
Proof: Suppose that is false, i.e., This means that there exists with such that . This means the the index is forbidden and unless is increased, the predicate can never become true irrespective of how other components of are increased. Β Β
We now have our LLP-based algorithm for Optimal Binary Search Tree as Algorithm 4. The program has a single variable . It is initialized so that equals and equals zero whenever is not equal to . The algorithm advances whenever it is smaller than . In Algorithm 4, we have used the awlways clause as a macro that uses as a short form for .
Although, the above algorithm will give us correct answers, it is not efficient as it may update before and for have stabilized. However, the following scheduling strategy ensures that we update at most once. We check for whether is forbidden in the order of . Hence, initially all such that are updated. This is followed by all such that , and so on. We capture this scheduling strategy with the statement. We pick to update such that have minimal values. Of course, our goal is to compute . With the above strategy of updating , we get that is updated at most once. Since there are possible values of and each takes work to update, we get the work complexity of . On a CREW PRAM, we can compute all with the fixed difference in parallel. By using span algorithm to compute , we get the parallel time complexity as . Thus, we have the following result.
Lemma 6
There exists a parallel algorithm for the optimal binary search tree problem which uses just read-write atomicity and solves it in parallel time.
We now consider the constrained versions of the problem.
Lemma 7
All the following predicates are lattice linear.
-
1.
Key is not a parent for any key.
-
2.
The difference in the sizes of the left subtree and the right subtree is at most .
Proof:
-
1.
This requirement changes the ensure predicate to . The right hand side of the constraint continues to be monotonic and therefore it is lattice linear.
-
2.
This requirement changes the ensure predicate to . This change simply restricts the values of , and the right hand side continues to be monotonic.
Β
Remark: A problem very similar to the optimal Binary Search tree problem is that of constructing an optimal way of multiplying a chain of matrices. Since matrix multiplication is associative, the product of matrices is equal to . However, depending upon the dimensions of the matrices, the computational effort may be different. We let the dimension of matrix be . Note that this keep the matrix product well-defined because the dimension of matrix would be and the product is well-defined. We can view any evaluation of a chain as a binary tree where the intermediate notes are the multiplication operation and the leaves are the matrices themselves. Suppose, our goal is to compute the optimal binary tree for multiplying matrices in the range . Borrowing ideas from the previous section, we let denote the optimal cost of computing the product of matrices in the range . Suppose that this product is broken into products of and and then multiplication of these two matrices. We can compute the cost of this tree as
Then, we have the following predicate on .
The reader will notice the similarity with the optimal binary search tree problem and this problem and the same algorithm can be adapted to solve this problem.
6 Knapsack Problem
We are given items with weights and values . We are also given a knapsack that has a capacity of . Our goal is to determine the subset of items that can be carried in the knapsack and that maximizes the total value. The standard dynamic programming solution is based on memoization of the following dynamic programming formulation [10, 11]. Let be the maximum value that can be obtained by picking items from with the capacity constraint of . Then, . The first argument of the max function corresponds to the case when the item is included in the optimal set from , and the second argument corresponds to the case when the item is not included and hence the entire capacity can be used for the items from . If , then the item can never be in the knapsack and can be skipped. The base cases are simple. The value of and is zero for all and . Our goal is to find . By filling up the two dimensional array for all values of and , we get an algorithm with time complexity .
We can model this problem using lattice-linear predicates as follows. We model the feasibility as for all and . Also, if or . Our goal is to find the minimum vector that satisfies feasibility.
Lemma 8
The constraint for is lattice-linear.
Proof: If the predicate is false, there exists and such that . The value is forbidden; unless is increased the predicate can never become true. Β Β
Algorithm 5 updates the value of based only on the values of . Furthermore, is always at least . Based on this observation, we can simplify the algorithm as follows. We consider the problem of adding just one item to the knapsack given the constraint that the total weight does not exceed . We maintain the list of all optimal configurations for each weight less than .
The incremental algorithm can be implemented in parallel time using processors as shown in Fig. 6. Each processor can check whether needs to be advanced.
We can now invoke the incremental Knapsack algorithm as Algorithm 7. If we had cores, then computing from can be done in giving us the span of .
We now add some lattice-linear constraints to the Knapsack problem. In many applications, some items may be related and the constraint means that if the item is included in the Knapsack then the item must also be included. Thus, the item has profit of zero if is not included. The item has utility even without but not vice-versa. Without loss of generality, we assume that all weights are strictly positive, and that index . In the following Lemma, we use an auxiliary variable that keeps the set of items included in and not just the profit from those items.
Lemma 9
First assume that . Let for and , otherwise. This predicate corresponds to any item different from . The value with a bag of capacity is always greater than or equal to the choice of picking the item or not picking the item.
Let if and , otherwise.
Then, is lattice-linear for all and .
Proof: Suppose that is false for some and . Unless is increased, it can never become true. Β Β
7 Conclusions
In this paper, we have shown that many dynamic programming problems can be solved using a single parallel Lattice-Linear Predicate algorithm. In particular, LLP algorithm solves the problem of the longest increasing subsequence, the optimal binary search tree and the knapsack problem. In addition, it solves the constrained versions of these problems. The parallel algorithms described in the paper works correctly with read-write atomicity of variables without any use of locks.
References
- [1] VijayΒ K. Garg. Predicate detection to solve combinatorial optimization problems. In Christian Scheideler and Michael Spear, editors, SPAA β20: 32nd ACM Symposium on Parallelism in Algorithms and Architectures, Virtual Event, USA, July 15-17, 2020, pages 235β245. ACM, 2020.
- [2] Richard Bellman. On the theory of dynamic programming. Proceedings of the National Academy of Sciences of the United States of America, 38(8):716, 1952.
- [3] G.Β Birkhoff. Lattice Theory. Providence, R.I., 1967. third edition.
- [4] B.Β A. Davey and H.Β A. Priestley. Introduction to Lattices and Order. Cambridge University Press, Cambridge, UK, 1990.
- [5] VijayΒ K Garg. Lattice Theory with Computer Science Applications. Wiley, New York, NY, 2015.
- [6] DonaldΒ E. Knuth. Optimum binary search trees. Acta informatica, 1(1):14β25, 1971.
- [7] Ellis Horowitz and Sartaj Sahni. Computing partitions with applications to the knapsack problem. Journal of the ACM (JACM), 21(2):277β292, 1974.
- [8] OscarΒ H Ibarra and ChulΒ E Kim. Fast approximation algorithms for the knapsack and sum of subset problems. Journal of the ACM (JACM), 22(4):463β468, 1975.
- [9] CraigΒ M Chase and VijayΒ K Garg. Detection of global predicates: Techniques and their limitations. Distributed Computing, 11(4):191β201, 1998.
- [10] VijayΒ V. Vazirani. Approximation Algorithms. Springer-Verlag, Berlin, Germany, 2001.
- [11] David BΒ Shmoys David PΒ Williamson. The Design of Approximation Algorithms. Cambridge University Press, 2010.